using Exferia_Aplicacion.Herencia.Capas;
using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using Exferia_Aplicacion.General;
using Exferia_EntityFramework;
using System.Runtime.CompilerServices;
using Exferia_Maestros._0_Modelos;
using Exferia_Maestros.General;
using Exferia_Aplicacion.Modelos_MantenimientoSimple;
using System.Transactions;
using System.Data.SqlClient;
using Exferia_General;
using System.Threading;
using static Exferia_Aplicacion.General.Enumerados;

namespace Exferia_Maestros._1_Datos
{
    public class MAE_Vendedores_Datos : ABS_Datos
    {
        #region Listado
        private List<INTERNO_MAE_Vendedores_Listado_Modelo> g_lst_INTERNO_MAE_Vendedores_Listado_Modelo = null;

        public override List<dynamic> Obtener_Listado(long _lng_idEmpresaSeleccionada, long _lng_idEjercicioActual, List<string> _lst_CamposConRelacionABuscar, List<INTERNO_Filtro_OpcionPadre_Modelo> _lst_INTERNO_Filtro_OpcionPadre_Modelo, List<INTERNO_Filtro_Modelo> _lst_INTERNO_Filtro_Modelo)
        {
            Exferia_Entities obj_Exferia_Entities = null;
            List<dynamic> lst_MAE = null;

            try
            {
                obj_Exferia_Entities = new Exferia_Entities();
                obj_Exferia_Entities.Configuration.LazyLoadingEnabled = false;

                // Consulta .....................................................
                ConsultaRellenar_Listado(obj_Exferia_Entities, _lng_idEmpresaSeleccionada, _lng_idEjercicioActual, Datos_Generales.GEN_Empresas_Devolver_EmpresasCompartidas_SegunFichero(_lng_idEmpresaSeleccionada, typeof(MAE_Vendedores).Name), _lst_CamposConRelacionABuscar, -1,null, _lst_INTERNO_Filtro_OpcionPadre_Modelo, _lst_INTERNO_Filtro_Modelo);
                // ..............................................................

                if ((g_lst_INTERNO_MAE_Vendedores_Listado_Modelo != null) && (g_lst_INTERNO_MAE_Vendedores_Listado_Modelo.Count() > 0))
                {
                    lst_MAE = g_lst_INTERNO_MAE_Vendedores_Listado_Modelo.Cast<dynamic>().ToList();
                }
            }
            catch (Control_Errores)
            {
                throw;
            }
            catch (Exception ex)
            {
                throw new Control_Errores("", ex, nameof(MAE_Vendedores_Datos) + "/" + nameof(Obtener_Listado), true);
            }
            finally
            {
                obj_Exferia_Entities.Database.Connection.Close();
                obj_Exferia_Entities.Dispose();
            }
            return lst_MAE;
        }
        public override dynamic Obtener_RegistroListado(long _lng_idEmpresaSeleccionada, long _lng_idEjercicioActual, List<string> _lst_CamposConRelacionABuscar, List<INTERNO_Filtro_OpcionPadre_Modelo> _lst_INTERNO_Filtro_OpcionPadre_Modelo, List<INTERNO_Filtro_Modelo> _lst_INTERNO_Filtro_Modelo, long _lng_id, List<long> _lst_ids)
        {
            Exferia_Entities obj_Exferia_Entities = null;
            dynamic dnm_MAE = null;

            try
            {
                obj_Exferia_Entities = new Exferia_Entities();
                obj_Exferia_Entities.Configuration.LazyLoadingEnabled = false;

                // Consulta .....................................................
                ConsultaRellenar_Listado(obj_Exferia_Entities, _lng_idEmpresaSeleccionada, _lng_idEjercicioActual, Datos_Generales.GEN_Empresas_Devolver_EmpresasCompartidas_SegunFichero(_lng_idEmpresaSeleccionada, typeof(MAE_Vendedores).Name), _lst_CamposConRelacionABuscar, _lng_id, _lst_ids, _lst_INTERNO_Filtro_OpcionPadre_Modelo, _lst_INTERNO_Filtro_Modelo);
                // ..............................................................

                if ((g_lst_INTERNO_MAE_Vendedores_Listado_Modelo != null) && (g_lst_INTERNO_MAE_Vendedores_Listado_Modelo.Count() > 0))
                {
                    dnm_MAE = g_lst_INTERNO_MAE_Vendedores_Listado_Modelo.Cast<dynamic>().ToList();
                }
            }
            catch (Control_Errores)
            {
                throw;
            }
            catch (Exception ex)
            {
                throw new Control_Errores("", ex, nameof(MAE_Vendedores_Datos) + "/" + nameof(Obtener_RegistroListado), true);
            }
            finally
            {
                obj_Exferia_Entities.Database.Connection.Close();
                obj_Exferia_Entities.Dispose();
            }
            return dnm_MAE;
        }
        protected override void ConsultaRellenar_Listado(Exferia_Entities _obj_Exferia_Entities, long _lng_idEmpresaSeleccionada, long _lng_idEjercicioActual, List<long> _lst_idEmpresasRelacionadas, List<string> _lst_CamposConRelacionABuscar, long _lng_id, List<long> _lst_ids, List<INTERNO_Filtro_OpcionPadre_Modelo> _lst_INTERNO_Filtro_OpcionPadre_Modelo, List<INTERNO_Filtro_Modelo> _lst_INTERNO_Filtro_Modelo)
        {
            try
            {
                List<SqlParameter> lst_Parametros = new List<SqlParameter>();

                string str_Filtros_Empresas = Funciones.Formar_ContenidoIN_ParaConsultaWhere(_lst_idEmpresasRelacionadas);

                //Filtros de Opciones
                //Datos del Padre si los tuviera .........................
                long lng_Padre_id = -1;
                string str_Padre_Opcion = "";
                if (_lst_INTERNO_Filtro_OpcionPadre_Modelo != null && _lst_INTERNO_Filtro_OpcionPadre_Modelo.Count>0)
                {
                    lng_Padre_id = _lst_INTERNO_Filtro_OpcionPadre_Modelo[0].VALOR;
                    str_Padre_Opcion = _lst_INTERNO_Filtro_OpcionPadre_Modelo[0].NOMBRE_CAMPO;
                }

                string str_SQL =
                      " SELECT " +
                          nameof(INTERNO_MAE_Vendedores_Listado_Modelo.id) + " = " + nameof(MAE_Vendedores) + "." + nameof(MAE_Vendedores.id) + "," +
                          nameof(INTERNO_MAE_Vendedores_Listado_Modelo.codigo) + " = " + nameof(MAE_Vendedores) + "." + nameof(MAE_Vendedores.codigo) + "," +
                          nameof(INTERNO_MAE_Vendedores_Listado_Modelo.nombre) + " = " + nameof(MAE_Vendedores) + "." + nameof(MAE_Vendedores.nombre) + "," +
                          nameof(INTERNO_MAE_Vendedores_Listado_Modelo.fechaAlta) + " = " + nameof(MAE_Vendedores) + "." + nameof(MAE_Vendedores.fechaAlta) + "," +
                          nameof(INTERNO_MAE_Vendedores_Listado_Modelo.fechaBaja) + " = " + nameof(MAE_Vendedores) + "." + nameof(MAE_Vendedores.fechaBaja) + "," +
                          nameof(INTERNO_MAE_Vendedores_Listado_Modelo.emailDocumentos) + " = " + nameof(MAE_Vendedores) + "." + nameof(MAE_Vendedores.emailDocumentos) + "," +
                          nameof(INTERNO_MAE_Vendedores_Listado_Modelo.noPermiteDevolucionDesechable) + " = " + nameof(MAE_Vendedores) + "." + nameof(MAE_Vendedores.noPermiteDevolucionDesechable) + "," +
                          //ids
                          nameof(INTERNO_MAE_Vendedores_Listado_Modelo.idEmpresa) + " = " + nameof(MAE_Vendedores) + "." + nameof(MAE_Vendedores.idEmpresa) + "," +
                          nameof(INTERNO_MAE_Vendedores_Listado_Modelo.idEmpleado) + " = " + nameof(MAE_Vendedores) + "." + nameof(MAE_Vendedores.idEmpleado) + "," +
                          //Empresa
                          (
                              (_lst_CamposConRelacionABuscar.Contains(nameof(INTERNO_MAE_Vendedores_Listado_Modelo.Empresa)))
                                ?
                                    (
                                        nameof(INTERNO_MAE_Vendedores_Listado_Modelo.Empresa_Codigo) + " = " + nameof(GEN_Empresas) + "." + nameof(GEN_Empresas.codigo) + "," +
                                        nameof(INTERNO_MAE_Vendedores_Listado_Modelo.Empresa_Descripcion) + " = " + nameof(GEN_Empresas) + "." + nameof(GEN_Empresas.descripcion) + "," +
                                        nameof(INTERNO_MAE_Vendedores_Listado_Modelo.Empresa_FechaBorrado) + " = " + nameof(GEN_Empresas) + "." + nameof(GEN_Empresas.fechaBorrado) + ","
                                    )
                                :
                                    (
                                        nameof(INTERNO_MAE_Vendedores_Listado_Modelo.Empresa_Codigo) + " = ''," +
                                        nameof(INTERNO_MAE_Vendedores_Listado_Modelo.Empresa_Descripcion) + "= '', " +
                                        nameof(INTERNO_MAE_Vendedores_Listado_Modelo.Empresa_FechaBorrado) + " = NULL ,"
                                    )
                          ) +
                          //Empleado
                          (
                              (_lst_CamposConRelacionABuscar.Contains(nameof(INTERNO_MAE_Vendedores_Listado_Modelo.Empleado)))
                                ?
                                    (
                                        nameof(INTERNO_MAE_Vendedores_Listado_Modelo.Empleado_Codigo) + " = " + nameof(MAE_Empleados) + "." + nameof(MAE_Empleados.codigo) + "," +
                                        nameof(INTERNO_MAE_Vendedores_Listado_Modelo.Empleado_Descripcion) + " = " + nameof(MAE_Empleados) + "." + nameof(MAE_Empleados.nombre) + "," +
                                        nameof(INTERNO_MAE_Vendedores_Listado_Modelo.Empleado_FechaBorrado) + " = " + nameof(MAE_Empleados) + "." + nameof(MAE_Empleados.fechaBorrado)   
                                    )
                                :
                                    (
                                        nameof(INTERNO_MAE_Vendedores_Listado_Modelo.Empleado_Codigo) + " = ''," +
                                        nameof(INTERNO_MAE_Vendedores_Listado_Modelo.Empleado_Descripcion) + " = ''," +
                                        nameof(INTERNO_MAE_Vendedores_Listado_Modelo.Empleado_FechaBorrado) + " = NULL "
                                    )
                          ) +
                          " FROM " + nameof(MAE_Vendedores) +
                          //Empresa
                          (
                             (_lst_CamposConRelacionABuscar.Contains(nameof(INTERNO_MAE_Vendedores_Listado_Modelo.Empresa)))
                                ?
                                    (
                                         " LEFT JOIN " + nameof(GEN_Empresas) + " ON " + nameof(MAE_Vendedores) + "." + nameof(MAE_Vendedores.idEmpresa) + " = " + nameof(GEN_Empresas) + "." + nameof(GEN_Empresas.id)
                                    )
                                : ("")
                          ) +
                          //Empleado
                          (
                             (_lst_CamposConRelacionABuscar.Contains(nameof(INTERNO_MAE_Vendedores_Listado_Modelo.Empleado)))
                                ?
                                    (
                                         " LEFT JOIN " + nameof(MAE_Empleados) + " ON " + nameof(MAE_Vendedores) + "." + nameof(MAE_Vendedores.idEmpleado) + " = " + nameof(MAE_Empleados) + "." + nameof(MAE_Empleados.id)
                                    )
                                : ("")
                          ) +
                          " WHERE " + nameof(MAE_Vendedores) + "." + nameof(MAE_Vendedores.fechaBorrado) + " IS null AND " +
                              " ( " + nameof(MAE_Vendedores) + "." + nameof(MAE_Vendedores.idEmpresa) + "=@idEmpresa " +
                                  (
                                      (_lst_idEmpresasRelacionadas != null && _lst_idEmpresasRelacionadas.Count > 0)
                                          ? (" OR " + nameof(MAE_Vendedores) + "." + nameof(MAE_Vendedores.idEmpresa) + " in (" + str_Filtros_Empresas + ") ")
                                          : " "
                                  ) +
                              " ) AND " +
                              (_lng_id > -1 ? nameof(MAE_Vendedores) + "." + (nameof(MAE_Vendedores.id) + "=@id") : "1 = 1") + " AND " +
                              //Filtro por datos del padre relacionado
                              (
                                  !str_Padre_Opcion.Equals("")
                                      //Empresa
                                      ? str_Padre_Opcion.Equals(Variables.G_STR_OPCION_GEN_EMPRESA)
                                          ? (nameof(MAE_Vendedores) + "." + nameof(MAE_Vendedores.idEmpresa) + "=@id_Padre")
                                          : ("1 = 1")
                                      : ("1 = 1")
                              );

                //Parametros
                lst_Parametros.Add(new SqlParameter("@idEmpresa", _lng_idEmpresaSeleccionada));
                lst_Parametros.Add(new SqlParameter("@id", _lng_id));
                lst_Parametros.Add(new SqlParameter("@id_Padre", lng_Padre_id));

                object[] arr_Parametros = lst_Parametros.ToArray();

                //Rellenar el Modelo
                g_lst_INTERNO_MAE_Vendedores_Listado_Modelo = _obj_Exferia_Entities.Database.SqlQuery<INTERNO_MAE_Vendedores_Listado_Modelo>(str_SQL, arr_Parametros).ToList();
            }
            catch (Control_Errores)
            {
                throw;
            }
            catch (Exception ex)
            {
                throw new Control_Errores("", ex, nameof(MAE_Vendedores_Datos) + "/" + nameof(ConsultaRellenar_Listado), true);
            }
        }
        #endregion

        #region Listado Secundario
        public override List<dynamic> Obtener_Listado_Secundario(long _lng_idEmpresaSeleccionada, long _lng_idEjercicioActual, List<string> _lst_CamposConRelacionABuscar, List<INTERNO_Filtro_OpcionPadre_Modelo> _lst_INTERNO_Filtro_OpcionPadre_Modelo, List<INTERNO_Filtro_Modelo> _lst_INTERNO_Filtro_Modelo)
        {
            return null;
        }
        public override dynamic Obtener_RegistroListado_Secundario(long _lng_idEmpresaSeleccionada, long _lng_idEjercicioActual, List<string> _lst_CamposConRelacionABuscar, List<INTERNO_Filtro_OpcionPadre_Modelo> _lst_INTERNO_Filtro_OpcionPadre_Modelo, List<INTERNO_Filtro_Modelo> _lst_INTERNO_Filtro_Modelo, long _lng_id, List<long> _lst_ids)
        {
            return null;
        }
        protected override void ConsultaRellenar_Listado_Secundario(Exferia_Entities _obj_Exferia_Entities, long _lng_idEmpresaSeleccionada, long _lng_idEjercicioActual, List<long> _lst_idEmpresasRelacionadas, List<string> _lst_CamposConRelacionABuscar, long _lng_id, List<long> _lst_ids, List<INTERNO_Filtro_OpcionPadre_Modelo> _lst_INTERNO_Filtro_OpcionPadre_Modelo, List<INTERNO_Filtro_Modelo> _lst_INTERNO_Filtro_Modelo)
        { }
        #endregion

        #region F3
        private INTERNO_MAE_Vendedores_Listado_Modelo g_mdl_INTERNO_MAE_Vendedores_Listado_Modelo = null;

        public override dynamic Obtener_F3(string _str_filtro, string _str_CampoBusqueda, long _lng_idEmpresaSeleccionada, long _lng_idEjercicioActual, List<INTERNO_Filtro_OpcionPadre_Modelo> _lst_INTERNO_Filtro_OpcionPadre_Modelo, List<INTERNO_Filtro_Modelo> _lst_INTERNO_Filtro_Modelo)
        {
            Exferia_Entities obj_Exferia_Entities = null;
            dynamic dnm_MAE = null;

            try
            {
                obj_Exferia_Entities = new Exferia_Entities();
                obj_Exferia_Entities.Configuration.LazyLoadingEnabled = false;

                //Consulta ......................................................
                ConsultaRellenar_F3(obj_Exferia_Entities, _lng_idEmpresaSeleccionada, _lng_idEjercicioActual, Datos_Generales.GEN_Empresas_Devolver_EmpresasCompartidas_SegunFichero(_lng_idEmpresaSeleccionada, typeof(MAE_Vendedores).Name), _str_CampoBusqueda, _str_filtro, -1, _lst_INTERNO_Filtro_OpcionPadre_Modelo, _lst_INTERNO_Filtro_Modelo);
                // ..............................................................

                if (g_mdl_INTERNO_MAE_Vendedores_Listado_Modelo != null)
                {
                    dnm_MAE = g_mdl_INTERNO_MAE_Vendedores_Listado_Modelo;
                }
            }
            catch (Control_Errores)
            {
                throw;
            }
            catch (Exception ex)
            {
                throw new Control_Errores("", ex, nameof(MAE_Vendedores_Datos) + "/" + nameof(Obtener_F3), true);
            }
            finally
            {
                obj_Exferia_Entities.Database.Connection.Close();
                obj_Exferia_Entities.Dispose();
            }
            return dnm_MAE;
        }
        public override dynamic Obtener_F3_PorId(long _lng_id, long _lng_idEmpresaSeleccionada, long _lng_idEjercicioActual, List<INTERNO_Filtro_OpcionPadre_Modelo> _lst_INTERNO_Filtro_OpcionPadre_Modelo, List<INTERNO_Filtro_Modelo> _lst_INTERNO_Filtro_Modelo)
        {
            Exferia_Entities obj_Exferia_Entities = null;
            dynamic dnm_MAE = null;

            try
            {
                obj_Exferia_Entities = new Exferia_Entities();
                obj_Exferia_Entities.Configuration.LazyLoadingEnabled = false;

                //Consulta ......................................................
                ConsultaRellenar_F3(obj_Exferia_Entities, _lng_idEmpresaSeleccionada, _lng_idEjercicioActual, Datos_Generales.GEN_Empresas_Devolver_EmpresasCompartidas_SegunFichero(_lng_idEmpresaSeleccionada, typeof(MAE_Vendedores).Name), "", "", _lng_id, _lst_INTERNO_Filtro_OpcionPadre_Modelo, _lst_INTERNO_Filtro_Modelo);
                // ..............................................................

                if (g_mdl_INTERNO_MAE_Vendedores_Listado_Modelo != null)
                {
                    dnm_MAE = g_mdl_INTERNO_MAE_Vendedores_Listado_Modelo;
                }
            }
            catch (Control_Errores)
            {
                throw;
            }
            catch (Exception ex)
            {
                throw new Control_Errores("", ex, nameof(MAE_Vendedores_Datos) + "/" + nameof(Obtener_F3_PorId), true);
            }
            finally
            {
                obj_Exferia_Entities.Database.Connection.Close();
                obj_Exferia_Entities.Dispose();
            }
            return dnm_MAE;
        }
        protected override void ConsultaRellenar_F3(Exferia_Entities _obj_Exferia_Entities, long _lng_idEmpresaSeleccionada, long _lng_idEjercicioActual, List<long> _lst_idEmpresasRelacionas, string _str_CampoBusqueda, string _str_Filtro, long _lng_id, List<INTERNO_Filtro_OpcionPadre_Modelo> _lst_INTERNO_Filtro_OpcionPadre_Modelo, List<INTERNO_Filtro_Modelo> _lst_INTERNO_Filtro_Modelo)
        {
            try
            {
                List<SqlParameter> lst_Parametros = new List<SqlParameter>();

                string str_Filtros_Empresas = Funciones.Formar_ContenidoIN_ParaConsultaWhere(_lst_idEmpresasRelacionas);

                //Filtros de Opciones
                //Datos del Padre si los tuviera .........................
                long lng_Padre_id = -1;
                string str_Padre_Opcion = "";
                if (_lst_INTERNO_Filtro_OpcionPadre_Modelo != null && _lst_INTERNO_Filtro_OpcionPadre_Modelo.Count > 0)
                {
                    lng_Padre_id = _lst_INTERNO_Filtro_OpcionPadre_Modelo[0].VALOR;
                    str_Padre_Opcion = _lst_INTERNO_Filtro_OpcionPadre_Modelo[0].NOMBRE_CAMPO;
                }

                string str_SQL =
                     " SELECT distinct " +
                         nameof(INTERNO_MAE_Vendedores_Listado_Modelo.id) + " = " + nameof(MAE_Vendedores.id) + "," +
                         nameof(INTERNO_MAE_Vendedores_Listado_Modelo.codigo) + " = " + nameof(MAE_Vendedores.codigo) + "," +
                         nameof(INTERNO_MAE_Vendedores_Listado_Modelo.nombre) + " = " + nameof(MAE_Vendedores.nombre) +
                     " FROM " + nameof(MAE_Vendedores) +
                     " WHERE " + nameof(MAE_Vendedores.fechaBorrado) + " IS null AND " +
                           " ( " + nameof(MAE_Vendedores) + "." + nameof(MAE_Vendedores.idEmpresa) + "=@idEmpresa " +
                                (
                                    (_lst_idEmpresasRelacionas != null && _lst_idEmpresasRelacionas.Count > 0)
                                        ? (" OR " + nameof(MAE_Vendedores) + "." + nameof(MAE_Vendedores.idEmpresa) + " in (" + str_Filtros_Empresas + ") ")
                                        : " "
                                ) +
                            " ) AND " +
                          (
                           (_lng_id > -1)
                             ? (nameof(MAE_Vendedores.id) + " = " + _lng_id)
                             : (
                                  //Filtrar por Codigo
                                  (_str_CampoBusqueda.Equals(nameof(MAE_Vendedores.codigo)))
                                      ? (nameof(MAE_Vendedores.codigo) + "=@Filtro")
                                      //Filtrar por Nombre
                                      : (nameof(MAE_Vendedores.nombre) + "=@Filtro")
                               )
                          )
                          + " AND " +
                          //Filtro por datos del padre relacionado
                          (
                              !str_Padre_Opcion.Equals("")
                                  //Empresa
                                  ? str_Padre_Opcion.Equals(Variables.G_STR_OPCION_GEN_EMPRESA)
                                      ? (nameof(MAE_Vendedores) + "." + nameof(MAE_Vendedores.idEmpresa) + "=@id_Padre")
                                      : ("1 = 1")
                                  : ("1 = 1")
                          );

                //Parametros
                lst_Parametros.Add(new SqlParameter("@idEmpresa", _lng_idEmpresaSeleccionada));
                lst_Parametros.Add(new SqlParameter("@Filtro", _str_Filtro));
                lst_Parametros.Add(new SqlParameter("@id_Padre", lng_Padre_id));

                object[] arr_Parametros = lst_Parametros.ToArray();

                //Rellenar el Modelo
                g_mdl_INTERNO_MAE_Vendedores_Listado_Modelo = _obj_Exferia_Entities.Database.SqlQuery<INTERNO_MAE_Vendedores_Listado_Modelo>(str_SQL, arr_Parametros).FirstOrDefault();
            }
            catch (Control_Errores)
            {
                throw;
            }
            catch (Exception ex)
            {
                throw new Control_Errores("", ex, nameof(MAE_Vendedores_Datos) + "/" + nameof(ConsultaRellenar_F3), true);
            }
        }
        #endregion

        #region Obtener

        #region Obtener Simple
        private dynamic g_dnm_Modelo_Obtener = null;

        private static int g_int_TotalHilos_Obtener = 1;
        private bool[] g_bol_Hilos_Terminados_Obtener = new bool[g_int_TotalHilos_Obtener];

        public override dynamic Obtener(long _lng_id)
        {
            Exferia_Entities obj_Exferia_Entities = null;

            try
            {
                obj_Exferia_Entities = new Exferia_Entities();
                obj_Exferia_Entities.Configuration.LazyLoadingEnabled = false;

                string str_SQL =
                           " SELECT " +
                               nameof(MAE_Vendedores) + "." + nameof(MAE_Vendedores.id) + " , " +
                               nameof(MAE_Vendedores) + "." + nameof(MAE_Vendedores.codigo) + " , " +
                               nameof(MAE_Vendedores) + "." + nameof(MAE_Vendedores.nombre) + " , " +
                               nameof(MAE_Vendedores) + "." + nameof(MAE_Vendedores.idEmpresa) + " , " +
                               nameof(MAE_Vendedores) + "." + nameof(MAE_Vendedores.fechaAlta) + " , " +
                               nameof(MAE_Vendedores) + "." + nameof(MAE_Vendedores.fechaBaja) + " , " +
                               nameof(MAE_Vendedores) + "." + nameof(MAE_Vendedores.emailDocumentos) + " , " +
                               nameof(MAE_Vendedores) + "." + nameof(MAE_Vendedores.fechaBorrado) + " , " +
                               nameof(MAE_Vendedores) + "." + nameof(MAE_Vendedores.idEmpleado) + " , " +
                               nameof(MAE_Vendedores) + "." + nameof(MAE_Vendedores.noPermiteDevolucionDesechable) +
                           " FROM " + nameof(MAE_Vendedores) +
                         " WHERE  " + nameof(MAE_Vendedores) + "." + nameof(MAE_Vendedores.fechaBorrado) + " IS null AND " +
                                      nameof(MAE_Vendedores) + "." + nameof(MAE_Vendedores.id) + "=@id ";

                //Parametros
                object[] arr_Parametros = new object[]
                {
                     new SqlParameter("@id",  _lng_id)
                };

                //Rellenar el Modelo
                g_dnm_Modelo_Obtener = obj_Exferia_Entities.Database.SqlQuery<MAE_Vendedores>(str_SQL, arr_Parametros).FirstOrDefault();

                #region Rellenar tablas Relacionadas
                if (g_dnm_Modelo_Obtener != null)
                {
                    //reiniciar Valores de los hilos
                    for (int int_Contador = 0; int_Contador < g_int_TotalHilos_Obtener; int_Contador++)
                    {
                        g_bol_Hilos_Terminados_Obtener[int_Contador] = false;
                    }

                    //MAE_Empleados ##########################################################################################
                    if(g_dnm_Modelo_Obtener.idEmpleado != null)
                    {
                        ThreadStart obj_ThreadStart_EMPLEADOS = new ThreadStart(Obtener_Empleado_Modelo_Obtener);
                        Thread obj_Thread_EMPLEADOS = new Thread(obj_ThreadStart_EMPLEADOS);
                        obj_Thread_EMPLEADOS.Start();
                    }
                    else
                    {
                        g_bol_Hilos_Terminados_Obtener[0] = true;
                    }

                    //Esperando a que terminen todos los hilos .........................................
                    bool bol_Termino = false;
                    while (bol_Termino == false)
                    {
                        bol_Termino = true;
                        foreach (bool bol_Termino_Hilo in g_bol_Hilos_Terminados_Obtener)
                        {
                            if (bol_Termino_Hilo == false)
                            {
                                bol_Termino = false;
                                break;
                            }
                        }

                        Thread.Sleep(10);
                    }
                    //.................................................................................
                }
                #endregion
            }
            catch (Control_Errores)
            {
                throw;
            }
            catch (Exception ex)
            {
                throw new Control_Errores("", ex, nameof(MAE_Vendedores_Datos) + "/" + nameof(Obtener), true);
            }
            finally
            {
                obj_Exferia_Entities.Database.Connection.Close();
                obj_Exferia_Entities.Dispose();
            }
            return g_dnm_Modelo_Obtener;
        }
        #region Tablas Relacionadas
        private void Obtener_Empleado_Modelo_Obtener()
        {
            try
            {
                MAE_Empleados_Datos obj_MAE_Empleados_Datos = new MAE_Empleados_Datos();
                g_dnm_Modelo_Obtener.MAE_Empleados = obj_MAE_Empleados_Datos.Obtener_Modelo_Por_Id(g_dnm_Modelo_Obtener.idEmpleado,false);
            }
            catch (Control_Errores)
            { }
            finally
            {
                g_bol_Hilos_Terminados_Obtener[0] = true;
            }
        }
       
        #endregion

        #endregion

        public override dynamic Obtener_Registro_PorCampo(string _str_Filtro, string _str_CampoBusqueda, long _lng_idEmpresaSeleccionada, long _lng_idEjercicioActual)
        {
            throw new NotImplementedException();
        }
        #endregion

        #region MODELOS

        #region Modelo Simple
        private MAE_Vendedores g_mdl_MAE_Vendedores = null;
        public MAE_Vendedores Obtener_Modelo_Por_Id(long _lng_id,
                                                    bool _bol_Cargar_Empresa)
        {
            try
            {
                string str_SQL = Obtener_Consulta_Modelo() +
                                  //WHERE
                                  " WHERE " + nameof(MAE_Vendedores) + "." + nameof(MAE_Vendedores.id) + "=@id";

                //Parametros
                object[] arr_Parametros = new object[]
                {
                     new SqlParameter("@id",  _lng_id)
                };

                //Ejecutar y rellenar el modelo
                Ejecutar_Consulta_Modelo(str_SQL,
                                         arr_Parametros,
                                         _bol_Cargar_Empresa,
                                         false);
            }
            catch (Control_Errores)
            {
                throw;
            }
            catch (Exception ex)
            {
                throw new Control_Errores("", ex, nameof(MAE_Vendedores_Datos) + "/" + nameof(Obtener_Modelo_Por_Id), true);
            }

            return g_mdl_MAE_Vendedores;
        }
        public MAE_Vendedores Obtener_Modelo_Por_Id(long _lng_id,
                                                    bool _bol_Cargar_Empresa,
                                                    bool _bol_Cargar_Empleado)
        {
            try
            {
                string str_SQL = Obtener_Consulta_Modelo() +
                                  //WHERE
                                  " WHERE " + nameof(MAE_Vendedores) + "." + nameof(MAE_Vendedores.id) + "=@id";

                //Parametros
                object[] arr_Parametros = new object[]
                {
                     new SqlParameter("@id",  _lng_id)
                };

                //Ejecutar y rellenar el modelo
                Ejecutar_Consulta_Modelo(str_SQL,
                                         arr_Parametros,
                                         _bol_Cargar_Empresa,
                                         _bol_Cargar_Empleado);
            }
            catch (Control_Errores)
            {
                throw;
            }
            catch (Exception ex)
            {
                throw new Control_Errores("", ex, nameof(MAE_Vendedores_Datos) + "/" + nameof(Obtener_Modelo_Por_Id), true);
            }

            return g_mdl_MAE_Vendedores;
        }

        #region Ejecutar Consulta
        private static int g_int_TotalHilos_Modelo = 2;
        private bool[] g_bol_Hilos_Terminados_Modelo = new bool[g_int_TotalHilos_Modelo];

        private void Ejecutar_Consulta_Modelo(string _str_SQL,
                                            object[] _arr_Parametros,
                                            bool _bol_Cargar_Empresa,
                                            bool _bol_Cargar_Empleado)
        {
            Exferia_Entities obj_Exferia_Entities = null;

            try
            {
                //Conexion
                obj_Exferia_Entities = new Exferia_Entities();
                obj_Exferia_Entities.Configuration.LazyLoadingEnabled = false;

                //Rellenar el Modelo
                g_mdl_MAE_Vendedores = obj_Exferia_Entities.Database.SqlQuery<MAE_Vendedores>(_str_SQL, _arr_Parametros).FirstOrDefault();

                #region Rellenar tablas Relacionadas
                if(g_mdl_MAE_Vendedores != null)
                {
                    if (_bol_Cargar_Empresa ||
                        _bol_Cargar_Empleado)
                    {
                        //reiniciar Valores de los hilos
                        for (int int_Contador = 0; int_Contador < g_int_TotalHilos_Modelo; int_Contador++)
                        {
                            g_bol_Hilos_Terminados_Modelo[int_Contador] = false;
                        }

                        //GEN_Empresas ##########################################################################################
                        if (_bol_Cargar_Empresa)
                        {
                            ThreadStart obj_ThreadStart_EMPRESA = new ThreadStart(Obtener_Empresa_Modelo);
                            Thread obj_Thread_EMPRESA = new Thread(obj_ThreadStart_EMPRESA);
                            obj_Thread_EMPRESA.Start();
                        }
                        else
                        {
                            g_bol_Hilos_Terminados_Modelo[0] = true;
                        }

                        //MAE_Empleado ##########################################################################################
                        if (_bol_Cargar_Empleado &&
                            g_mdl_MAE_Vendedores.idEmpleado!=null)
                        {
                            ThreadStart obj_ThreadStart_EMPLEADO = new ThreadStart(Obtener_Empleado_Modelo);
                            Thread obj_Thread_EMPLEADO = new Thread(obj_ThreadStart_EMPLEADO);
                            obj_Thread_EMPLEADO.Start();
                        }
                        else
                        {
                            g_bol_Hilos_Terminados_Modelo[1] = true;
                        }

                        //Esperando a que terminen todos los hilos .........................................
                        bool bol_Termino = false;
                        while (bol_Termino == false)
                        {
                            bol_Termino = true;
                            foreach (bool bol_Termino_Hilo in g_bol_Hilos_Terminados_Modelo)
                            {
                                if (bol_Termino_Hilo == false)
                                {
                                    bol_Termino = false;
                                    break;
                                }
                            }

                            Thread.Sleep(10);
                        }
                        //.................................................................................
                    }
                }
                #endregion
            }
            catch (Control_Errores)
            {
                throw;
            }
            catch (Exception ex)
            {
                throw new Control_Errores("", ex, nameof(MAE_Vendedores) + "/" + nameof(Ejecutar_Consulta_Modelo), true);
            }
            finally
            {
                obj_Exferia_Entities.Database.Connection.Close();
                obj_Exferia_Entities.Dispose();
            }
        }

        #region Tablas Relacionadas
        private void Obtener_Empresa_Modelo()
        {
            try
            {
                g_mdl_MAE_Vendedores.GEN_Empresas = Datos_Generales.GEN_Empresas_Obtener_Modelo_Por_Id(g_mdl_MAE_Vendedores.idEmpresa,
                                                                                                       false,
                                                                                                       false,
                                                                                                       false,
                                                                                                       true);
            }
            catch (Control_Errores)
            { }
            finally
            {
                g_bol_Hilos_Terminados_Modelo[0] = true;
            }
        }

        private void Obtener_Empleado_Modelo()
        {
            try
            {
                MAE_Empleados_Datos obj_MAE_Empleados_Datos = new MAE_Empleados_Datos();
                g_mdl_MAE_Vendedores.MAE_Empleados= obj_MAE_Empleados_Datos.Obtener_Modelo_Por_Id(g_mdl_MAE_Vendedores.idEmpleado.Value,true);

            }
            catch (Control_Errores)
            { }
            finally
            {
                g_bol_Hilos_Terminados_Modelo[1] = true;
            }
        }
        #endregion

        #endregion

        #endregion

        #region Modelo Listado
        private List<MAE_Vendedores> g_lst_MAE_Vendedores = null;

        public List<MAE_Vendedores> Obtener_ModeloListado_Por_Ids(List<long> _lst_Ids,
                                                                  bool _bol_Cargar_Empresa)
        {
            try
            {
                if (_lst_Ids != null && _lst_Ids.Count > 0)
                {
                    string str_Filtro_IDS = Funciones.Formar_ContenidoIN_ParaConsultaWhere(nameof(MAE_Vendedores),
                                                                                            nameof(MAE_Vendedores.id),
                                                                                            G_ENUM_FORMARCONTENIDOIN_CONDICIONANTES.NADA,
                                                                                            _lst_Ids);

                    //Consulta
                    string str_SQL = Obtener_Consulta_Modelo() +
                                                " WHERE " +
                                                    str_Filtro_IDS;

                    //Ejecutar y rellenar el listado
                    Ejecutar_Consulta_Modelo_Listado(str_SQL,
                                                     new object[] { },
                                                     _bol_Cargar_Empresa);
                }
            }
            catch (Control_Errores)
            {
                throw;
            }
            catch (Exception ex)
            {
                throw new Control_Errores("", ex, nameof(MAE_Vendedores_Datos) + "/" + nameof(Obtener_ModeloListado_Por_Ids), true);
            }

            return g_lst_MAE_Vendedores;
        }

        #region Ejecutar Consulta
        //Listado de modelos Relacionados
        private List<GEN_Empresas> g_lst_GEN_Empresas = null;

        //Hilos
        private static int g_int_TotalHilos_Modelo_Listado = 1;
        private bool[] g_bol_Hilos_Terminados_Modelo_Listado = new bool[g_int_TotalHilos_Modelo_Listado];

        private void Ejecutar_Consulta_Modelo_Listado(string _str_SQL,
                                                    object[] _arr_Parametros,
                                                    bool _bol_Cargar_Empresa)
        {
            Exferia_Entities obj_Exferia_Entities = null;

            try
            {
                //Conexion
                obj_Exferia_Entities = new Exferia_Entities();
                obj_Exferia_Entities.Configuration.LazyLoadingEnabled = false;


                //Rellenar el modelo
                g_lst_MAE_Vendedores = obj_Exferia_Entities.Database.SqlQuery<MAE_Vendedores>(_str_SQL, _arr_Parametros).ToList();

                #region Rellenar Tablas RElacionadas
                if(g_lst_MAE_Vendedores != null && g_lst_MAE_Vendedores.Count > 0)
                {
                    
                    //Si tiene que buscar alguna tabla relacionada
                    if (_bol_Cargar_Empresa)
                    {
                        #region PRIMERO BUSCO LOS DATOS DE LAS TABLAS RELACIONADAS
                        //reiniciar Valores de los hilos
                        for (int int_Contador = 0; int_Contador < g_int_TotalHilos_Modelo_Listado; int_Contador++)
                        {
                            g_bol_Hilos_Terminados_Modelo_Listado[int_Contador] = false;
                        }

                        //GEN_Empresas #############################################
                        if (_bol_Cargar_Empresa)
                        {
                            ThreadStart obj_ThreadStart_EMPRESA = new ThreadStart(Obtener_Empresa_Modelo_Listado);
                            Thread obj_Thread_EMPRESA = new Thread(obj_ThreadStart_EMPRESA);
                            obj_Thread_EMPRESA.Start();
                        }
                        else
                        {
                            g_bol_Hilos_Terminados_Modelo_Listado[0] = true;
                        }

                        //Esperando a que terminen todos los hilos .........................................
                        bool bol_Termino = false;
                        while (bol_Termino == false)
                        {
                            bol_Termino = true;
                            foreach (bool bol_Termino_Hilo in g_bol_Hilos_Terminados_Modelo_Listado)
                            {
                                if (bol_Termino_Hilo == false)
                                {
                                    bol_Termino = false;
                                    break;
                                }
                            }

                            Thread.Sleep(10);
                        }
                        //.................................................................................
                        #endregion

                        #region DESPUES SE LO VOY ASIGNANDO A LOS REGISTRO UNO A UNO
                        foreach (MAE_Vendedores mdl_MAE_Vendedores in g_lst_MAE_Vendedores)
                        {
                            //GEN_Empresas #############################################
                            if (_bol_Cargar_Empresa &&
                                g_lst_GEN_Empresas != null &&
                                g_lst_GEN_Empresas.Count > 0)
                            {
                                mdl_MAE_Vendedores.GEN_Empresas = g_lst_GEN_Empresas.Where(m => m.id == mdl_MAE_Vendedores.idEmpresa).FirstOrDefault();
                            }
                        }
                        #endregion
                    }
                    
                }
                #endregion


            }
            catch (Control_Errores)
            {
                throw;
            }
            catch (Exception ex)
            {
                throw new Control_Errores("", ex, nameof(MAE_Vendedores_Datos) + "/" + nameof(Ejecutar_Consulta_Modelo_Listado), true);
            }
            finally
            {
                obj_Exferia_Entities.Database.Connection.Close();
                obj_Exferia_Entities.Dispose();
            }
        }

        #region Tablas Relacionadas
        private void Obtener_Empresa_Modelo_Listado()
        {
            try
            {
                g_lst_GEN_Empresas = Datos_Generales.GEN_Empresas_Obtener_Modelo_Listado_Por_Ids(g_lst_MAE_Vendedores.Select(m => m.idEmpresa).ToList());
            }
            catch (Control_Errores)
            { }
            finally
            {
                g_bol_Hilos_Terminados_Modelo_Listado[0] = true;
            }
        }
        #endregion

        #endregion

        #endregion

        private string Obtener_Consulta_Modelo()
        {
            return
               " SELECT " +
                   nameof(MAE_Vendedores) + "." + nameof(MAE_Vendedores.id) + " , " +
                   nameof(MAE_Vendedores) + "." + nameof(MAE_Vendedores.codigo) + " , " +
                   nameof(MAE_Vendedores) + "." + nameof(MAE_Vendedores.nombre) + " , " +
                   nameof(MAE_Vendedores) + "." + nameof(MAE_Vendedores.idEmpresa) + " , " +
                   nameof(MAE_Vendedores) + "." + nameof(MAE_Vendedores.fechaAlta) + " , " +
                   nameof(MAE_Vendedores) + "." + nameof(MAE_Vendedores.fechaBaja) + " , " +
                   nameof(MAE_Vendedores) + "." + nameof(MAE_Vendedores.emailDocumentos) + " , " +
                   nameof(MAE_Vendedores) + "." + nameof(MAE_Vendedores.fechaBorrado) + " , " +
                   nameof(MAE_Vendedores) + "." + nameof(MAE_Vendedores.idEmpleado) + " , " +
                   nameof(MAE_Vendedores) + "." + nameof(MAE_Vendedores.noPermiteDevolucionDesechable) +
               " FROM " + nameof(MAE_Vendedores);
        }
        #endregion

        #region Grabar
        public override INTERNO_ValorDevuelto_Modelo Grabar(object _mdl_obj)
        {
            Exferia_Entities obj_Exferia_Entities = null;

            INTERNO_ValorDevuelto_Modelo mdl_INTERNO_ValorDevuelto_Modelo = new INTERNO_ValorDevuelto_Modelo();
            mdl_INTERNO_ValorDevuelto_Modelo.TodoCorrecto = true;

            try
            {
                obj_Exferia_Entities = new Exferia_Entities();
                obj_Exferia_Entities.Configuration.LazyLoadingEnabled = false;

                MAE_Vendedores mdl_MAE_Vendedores_AGrabar = (MAE_Vendedores)_mdl_obj;
                MAE_Vendedores mdl_MAE_Vendedores_DatosViejos = new MAE_Vendedores();

                // Ver si existe ######################################################################
                MAE_Vendedores mdl_MAE_Vendedores_Final = Obtener_Modelo_Por_Id(mdl_MAE_Vendedores_AGrabar.id, false);
                //###################################################################################### 

                //UPDATE
                if (mdl_MAE_Vendedores_Final != null)
                {
                    //Tipo de Accion que se va a realizar
                    mdl_INTERNO_ValorDevuelto_Modelo.TipoAccion = Enumerados.G_ENUM_TIPOACCION.INT_MODIFICAR;

                    //Datos viejos para la trazabilidad
                    Funciones.CopiarPropiedadesObjetos(mdl_MAE_Vendedores_Final, mdl_MAE_Vendedores_DatosViejos, false, false);

                    // Cargar los Datos Nuevos del Modelo
                    Funciones.CopiarPropiedadesObjetos(mdl_MAE_Vendedores_AGrabar, mdl_MAE_Vendedores_Final, false, false);

                    #region UPDATE
                    string str_SQL_Update = " UPDATE " + nameof(MAE_Vendedores) +
                                           " SET " +
                                               nameof(MAE_Vendedores.codigo) + "=@codigo," +
                                               nameof(MAE_Vendedores.nombre) + "=@nombre," +
                                               nameof(MAE_Vendedores.idEmpresa) + "=@idEmpresa," +
                                               nameof(MAE_Vendedores.fechaAlta) + "=@fechaAlta," +
                                               nameof(MAE_Vendedores.fechaBaja) + "=@fechaBaja," +
                                               nameof(MAE_Vendedores.emailDocumentos) + "=@emailDocumentos," +
                                               nameof(MAE_Vendedores.fechaBorrado) + "=@fechaBorrado," +
                                               nameof(MAE_Vendedores.idEmpleado) + "=@idEmpleado," +
                                               nameof(MAE_Vendedores.noPermiteDevolucionDesechable) + "=@noPermiteDevolucionDesechable " +
                                           " WHERE " +
                                               nameof(MAE_Vendedores.id) + "=@id";

                    //Parametros
                    object[] arr_Parametros_Update = new object[]
                    {
                        new SqlParameter("@codigo",  mdl_MAE_Vendedores_AGrabar.codigo),
                        new SqlParameter("@nombre",  mdl_MAE_Vendedores_AGrabar.nombre),
                        new SqlParameter("@idEmpresa",  mdl_MAE_Vendedores_AGrabar.idEmpresa),
                        new SqlParameter("@fechaAlta",  mdl_MAE_Vendedores_AGrabar.fechaAlta),
                        mdl_MAE_Vendedores_AGrabar.fechaBaja!=null
                            ?   new SqlParameter("@fechaBaja", mdl_MAE_Vendedores_AGrabar.fechaBaja.Value)
                            :   new SqlParameter("@fechaBaja",  DBNull.Value),
                        mdl_MAE_Vendedores_AGrabar.emailDocumentos != null
                            ?   new SqlParameter("@emailDocumentos", mdl_MAE_Vendedores_AGrabar.emailDocumentos)
                            :   new SqlParameter("@emailDocumentos",  DBNull.Value),
                        mdl_MAE_Vendedores_AGrabar.fechaBorrado!=null
                            ?   new SqlParameter("@fechaBorrado", mdl_MAE_Vendedores_AGrabar.fechaBorrado.Value)
                            :   new SqlParameter("@fechaBorrado",  DBNull.Value),
                        mdl_MAE_Vendedores_AGrabar.idEmpleado!=null
                            ?   new SqlParameter("@idEmpleado", mdl_MAE_Vendedores_AGrabar.idEmpleado.Value)
                            :   new SqlParameter("@idEmpleado",  DBNull.Value),
                        mdl_MAE_Vendedores_AGrabar.noPermiteDevolucionDesechable!=null
                            ?   new SqlParameter("@noPermiteDevolucionDesechable", mdl_MAE_Vendedores_AGrabar.noPermiteDevolucionDesechable.Value)
                            :   new SqlParameter("@noPermiteDevolucionDesechable",  DBNull.Value),
                        new SqlParameter("@id",  mdl_MAE_Vendedores_AGrabar.id)
                    };

                    #endregion

                    //Update
                    obj_Exferia_Entities.Database.ExecuteSqlCommand(str_SQL_Update, arr_Parametros_Update);

                    //Id de la tabla
                    mdl_INTERNO_ValorDevuelto_Modelo.Id = mdl_MAE_Vendedores_AGrabar.id;
                }
                //INSERT
                else
                {
                    mdl_MAE_Vendedores_Final = new MAE_Vendedores();

                    //Tipo de Accion que se va a realizar
                    mdl_INTERNO_ValorDevuelto_Modelo.TipoAccion = Enumerados.G_ENUM_TIPOACCION.INT_INSERTAR;

                    // Cargar los Datos del Modelo
                    Funciones.CopiarPropiedadesObjetos(mdl_MAE_Vendedores_AGrabar, mdl_MAE_Vendedores_Final, false, false);

                    #region INSERT
                    string str_SQL_Insert = " INSERT INTO " + nameof(MAE_Vendedores) +
                                               " (" +
                                                       nameof(MAE_Vendedores.codigo) + "," +
                                                       nameof(MAE_Vendedores.nombre) + "," +
                                                       nameof(MAE_Vendedores.idEmpresa) + "," +
                                                       nameof(MAE_Vendedores.fechaAlta) + "," +
                                                       nameof(MAE_Vendedores.fechaBaja) + "," +
                                                       nameof(MAE_Vendedores.emailDocumentos) + "," +
                                                       nameof(MAE_Vendedores.fechaBorrado) + "," +
                                                       nameof(MAE_Vendedores.idEmpleado) + "," +
                                                       nameof(MAE_Vendedores.noPermiteDevolucionDesechable) +
                                               " ) " +
                                               " OUTPUT INSERTED." + nameof(MAE_Vendedores.id) +
                                               " VALUES " +
                                               " ( " +
                                                   "@codigo," +
                                                   "@nombre," +
                                                   "@idEmpresa," +
                                                   "@fechaAlta," +
                                                   "@fechaBaja," +
                                                   "@emailDocumentos," +
                                                   "@fechaBorrado," +
                                                   "@idEmpleado," +
                                                   "@noPermiteDevolucionDesechable" +
                                               " ) ";

                    //Parametros
                    object[] arr_Parametros_Insert = new object[]
                    {
                        new SqlParameter("@codigo",  mdl_MAE_Vendedores_AGrabar.codigo),
                        new SqlParameter("@nombre",  mdl_MAE_Vendedores_AGrabar.nombre),
                        new SqlParameter("@idEmpresa",  mdl_MAE_Vendedores_AGrabar.idEmpresa),
                        new SqlParameter("@fechaAlta",  mdl_MAE_Vendedores_AGrabar.fechaAlta),
                        mdl_MAE_Vendedores_AGrabar.fechaBaja!=null
                            ?   new SqlParameter("@fechaBaja", mdl_MAE_Vendedores_AGrabar.fechaBaja.Value)
                            :   new SqlParameter("@fechaBaja",  DBNull.Value),
                        mdl_MAE_Vendedores_AGrabar.emailDocumentos != null
                            ?   new SqlParameter("@emailDocumentos", mdl_MAE_Vendedores_AGrabar.emailDocumentos)
                            :   new SqlParameter("@emailDocumentos",  DBNull.Value),
                        mdl_MAE_Vendedores_AGrabar.fechaBorrado!=null
                            ?   new SqlParameter("@fechaBorrado", mdl_MAE_Vendedores_AGrabar.fechaBorrado.Value)
                            :   new SqlParameter("@fechaBorrado",  DBNull.Value),
                        mdl_MAE_Vendedores_AGrabar.idEmpleado!=null
                            ?   new SqlParameter("@idEmpleado", mdl_MAE_Vendedores_AGrabar.idEmpleado.Value)
                            :   new SqlParameter("@idEmpleado",  DBNull.Value),
                        mdl_MAE_Vendedores_AGrabar.noPermiteDevolucionDesechable!=null
                            ?   new SqlParameter("@noPermiteDevolucionDesechable", mdl_MAE_Vendedores_AGrabar.noPermiteDevolucionDesechable.Value)
                            :   new SqlParameter("@noPermiteDevolucionDesechable",  DBNull.Value),
                    };
                    #endregion

                    //Id de la tabla
                    mdl_INTERNO_ValorDevuelto_Modelo.Id = obj_Exferia_Entities.Database.SqlQuery<long>(str_SQL_Insert, arr_Parametros_Insert).Single();
                }

                // Grabar un registro de trazabilidad con los datos de la transaccion realizada.
                Datos_Generales.USR_Trazabilidad_Grabar(typeof(MAE_Vendedores), mdl_MAE_Vendedores_DatosViejos, mdl_MAE_Vendedores_Final, mdl_INTERNO_ValorDevuelto_Modelo.TipoAccion, obj_Exferia_Entities);
            }
            catch (Control_Errores)
            {
                throw;
            }
            catch (Exception ex)
            {
                throw new Control_Errores("", ex, nameof(MAE_Vendedores_Datos) + "/" + nameof(Grabar), true);
            }
            finally
            {
                
                obj_Exferia_Entities.Database.Connection.Close();
                obj_Exferia_Entities.Dispose();
            }

            return mdl_INTERNO_ValorDevuelto_Modelo;
        }
        #endregion

        #region Borrar
        public override INTERNO_ValorDevuelto_Modelo Borrar(long _lng_id)
        {
            Exferia_Entities obj_Exferia_Entities = null;

            INTERNO_ValorDevuelto_Modelo mdl_ValorDevuelto_Modelo = new INTERNO_ValorDevuelto_Modelo();
            mdl_ValorDevuelto_Modelo.TodoCorrecto = true;

            //Tipo de Accion que se va a realizar
            mdl_ValorDevuelto_Modelo.TipoAccion = Enumerados.G_ENUM_TIPOACCION.INT_ELIMINAR;

            try
            {
                obj_Exferia_Entities = new Exferia_Entities();
                obj_Exferia_Entities.Configuration.LazyLoadingEnabled = false;

                // Ver si existe ######################################################################
                MAE_Vendedores mdl_MAE_Vendedores_Final = Obtener_Modelo_Por_Id(_lng_id, false);
                //######################################################################################

                if(mdl_MAE_Vendedores_Final != null)
                {
                    #region UPDATE
                    string str_SQL_Update = " UPDATE " + nameof(MAE_Vendedores) +
                                               " SET " +
                                               nameof(MAE_Vendedores.fechaBorrado) + "=@fechaBorrado " +
                                           " WHERE " +
                                               nameof(MAE_Vendedores.id) + "=@id";
                    //Parametros
                    object[] arr_Parametros_Update = new object[]
                    {
                        new SqlParameter("@fechaBorrado",  DateTime.Now),
                        new SqlParameter("@id", _lng_id)
                    };
                    #endregion

                    //Update
                    obj_Exferia_Entities.Database.ExecuteSqlCommand(str_SQL_Update, arr_Parametros_Update);

                    // Grabar un registro de trazabilidad con los datos de la transaccion realizada.
                    Datos_Generales.USR_Trazabilidad_Grabar(typeof(MAE_Vendedores), null, mdl_MAE_Vendedores_Final, Enumerados.G_ENUM_TIPOACCION.INT_ELIMINAR, obj_Exferia_Entities);
                }

                // Devolver también el Objeto
                mdl_ValorDevuelto_Modelo.Id = _lng_id;

            }
            catch (Control_Errores)
            {
                throw;
            }
            catch (Exception ex)
            {
                throw new Control_Errores("", ex, nameof(MAE_Vendedores_Datos) + "/" + nameof(Borrar), true);
            }
            finally
            {
                
                obj_Exferia_Entities.Database.Connection.Close();
                obj_Exferia_Entities.Dispose();
            }

            return mdl_ValorDevuelto_Modelo;
        }
        public override INTERNO_ValorDevuelto_Modelo Borrar(long _lng_id, long _lng_idAuxiliar)
        {
            throw new NotImplementedException();
        }
        public override INTERNO_ValorDevuelto_Modelo Borrar(object _mdl_obj)
        {
            return null;
        }
        #endregion
    }
}
